<template>
  <div id="accesstoken">
    <!-- Modal Create Access Token -->
    <CoscineModal
      v-model="isCreateModalVisible"
      :title="$t('page.userprofile.form.accessToken.modal.createToken.title')"
      :body="$t('page.userprofile.form.accessToken.modal.createToken.body')"
    >
      <div class="create-modal-content">
        <b-input-group id="tokenButtonGroup" style="width: 100%">
          <b-form-textarea
            id="accessToken"
            v-model="v$.token.accessToken.$model"
            :disabled="true"
            :readonly="true"
            rows="7"
            no-resize
          />
          <template #append>
            <b-button
              id="copyButton"
              style="margin: inherit"
              variant="primary"
              @click="copyToken"
            >
              <i-bi-clipboard />
            </b-button>
          </template>
          <b-tooltip ref="tooltip" target="copyButton" triggers="focus">
            {{
              $t(
                "page.userprofile.form.accessToken.modal.createToken.copyToClipboard",
              )
            }}
          </b-tooltip>
        </b-input-group>
      </div>
      <template #buttons>
        <div align="right">
          <b-button name="close" @click="isCreateModalVisible = false">
            {{ $t("buttons.close") }}
          </b-button>
        </div>
      </template>
    </CoscineModal>

    <!-- Modal Revoke Access Token -->
    <CoscineModal
      v-model="isRevokeModalVisible"
      :title="$t('page.userprofile.form.accessToken.modal.revokeToken.title')"
      :body="$t('page.userprofile.form.accessToken.modal.revokeToken.body')"
    >
      <br />
      <div class="revoke-modal-content">{{ selectedTokenName }}</div>
      <template #buttons>
        <b-button name="close" @click="isRevokeModalVisible = false">
          {{ $t("buttons.cancel") }}
        </b-button>
        <b-button
          name="deleteToken"
          variant="danger"
          style="float: right"
          @click="confirmRevoke"
        >
          {{ $t("buttons.revoke") }}
        </b-button>
      </template>
    </CoscineModal>

    <!-- Access Token -->
    <b-form-group
      class="mb-2"
      label-for="TokenBodytext"
      label-cols-sm="3"
      label-align-sm="right"
    >
      <!-- Token Body Text -->
      <b-form-text id="TokenBodytext" style="text-align: left">
        {{ $t("page.userprofile.form.accessToken.bodyText") }}
      </b-form-text>
    </b-form-group>

    <!-- Token Name -->
    <b-form-group
      class="mandatory mb-2"
      label-for="tokenName"
      label-cols-sm="3"
      label-align-sm="right"
      :label="$t('page.userprofile.form.accessToken.labels.tokenNameLabel')"
    >
      <b-form-input
        id="tokenName"
        v-model="v$.token.tokenName.$model"
        :placeholder="$t('page.userprofile.form.accessToken.tokenName')"
      />
    </b-form-group>
    <!-- Expires on -->
    <b-form-group
      class="mb-2"
      label-for="ExpiredDate"
      label-cols-sm="3"
      label-align-sm="right"
      :label="$t('page.userprofile.form.accessToken.labels.tokenExpireLabel')"
    >
      <b-form-input
        v-model="v$.token.tokenExpirationDate.$model"
        type="date"
        :min="tokenValidityBounds.minDate.toISOString().substring(0, 10)"
        :max="tokenValidityBounds.maxDate.toISOString().substring(0, 10)"
        :locale="$i18n.locale"
        :placeholder="$t('page.userprofile.form.accessToken.tokenExpire')"
      />
    </b-form-group>
    <!-- Create Access Token Button -->
    <b-form-group label-cols-sm="3" label-align-sm="right" class="mb-2">
      <b-button
        type="button"
        variant="secondary"
        class="float-end"
        name="create-token"
        style="margin-right: 0px"
        :disabled="v$.token.$invalid"
        @click.prevent="createToken"
        >{{ $t("buttons.tokenCreate") }}</b-button
      >
    </b-form-group>

    <!-- Token Table -->
    <b-form-group
      label-for="Token-List"
      label-cols-sm="3"
      label-align-sm="right"
    >
      <b-placeholder-wrapper :loading="isLoading">
        <!-- Loading Template -->
        <template #loading>
          <b-placeholder-table
            id="Token-List"
            class="mb-0"
            :columns="4"
            :rows="tokens ? tokens.length : undefined"
            fixed
            sticky-header="100%"
            no-border-collapse
          />
        </template>

        <!-- Table -->
        <b-table
          id="Token-List"
          :fields="headers"
          :items="tokens"
          :locale="$i18n.locale"
          :show-empty="true"
          :empty-text="$t('page.userprofile.form.accessToken.table.emptyText')"
          class="mb-0 text-start"
          fixed
          small
          striped
          sticky-header="100%"
          no-border-collapse
        >
          <template #cell(created)="row">
            <div>
              {{ formatDate(row.item.creationDate ?? "") }}
            </div>
          </template>
          <template #cell(expires)="row">
            <div
              :class="{ 'text-danger': checkExpiration(row.item.expiryDate) }"
            >
              {{ formatDate(row.item.expiryDate ?? "") }}
            </div>
          </template>

          <!-- Revoke Token Button -->
          <template #cell(actions)="selectedToken">
            <b-button
              size="sm"
              variant="danger"
              @click="revokeToken(selectedToken.item)"
            >
              {{ $t("buttons.revoke") }}
            </b-button>
          </template>
        </b-table>
      </b-placeholder-wrapper>
    </b-form-group>
  </div>
</template>

<script lang="ts">
import { required } from "@vuelidate/validators";
import { useVuelidate } from "@vuelidate/core";

// import the store for current module
import useUserStore from "../../store";
import moment from "moment";
import type {
  ApiTokenDto,
  ApiTokenForCreationDto,
} from "@coscine/api-client/dist/types/Coscine.Api";
import type { TokenValidityBoundDates } from "../../types";

const today = moment();

export default defineComponent({
  setup() {
    const userStore = useUserStore();

    /*
      Definition of the validation rules and initial state
      will enable proper typings in the code
    */
    const tokenForm = reactive({
      token: {
        tokenExpirationDate: new Date(),
        tokenName: "",
        accessToken: "",
      },
    });
    const tokenRules = {
      token: {
        tokenExpirationDate: {},
        tokenName: { required },
        accessToken: {},
      },
    };
    const v$ = useVuelidate(tokenRules, tokenForm);

    return { userStore, v$, tokenForm };
  },
  data() {
    return {
      isLoading: false,
      isCreateModalVisible: false,
      isRevokeModalVisible: false,
      headers: [
        {
          label: this.$t("page.userprofile.form.accessToken.tokenName"),
          key: "name",
        },
        {
          label: this.$t(
            "page.userprofile.form.accessToken.table.tokenCreated",
          ),
          key: "created",
        },
        {
          label: this.$t(
            "page.userprofile.form.accessToken.table.tokenExpires",
          ),
          key: "expires",
        },
        {
          label: this.$t("page.userprofile.form.accessToken.table.tokenAction"),
          key: "actions",
        },
      ],
      selectedTokenId: "",
      selectedTokenName: "",
      externalUser: true,
    };
  },

  computed: {
    tokens(): ApiTokenDto[] | undefined {
      return this.userStore.userProfile.tokens ?? undefined;
    },
    tokenValidityBounds(): TokenValidityBoundDates {
      const min = 7; // Hardcoded value
      const max = 370; // Hardcoded value

      // Set minimum date from API
      const minDate = moment(today).add(min, "days").toDate();
      // Set maximum date from API
      const maxDate = moment(today).add(max, "days").toDate();

      return {
        minDate: minDate,
        maxDate: maxDate,
      };
    },
  },

  watch: {
    tokenValidityBounds() {
      this.updateDateSelection();
    },
  },

  created() {
    this.updateDateSelection();
  },

  methods: {
    updateDateSelection() {
      this.tokenForm.token.tokenExpirationDate = moment(
        this.tokenValidityBounds.minDate,
      ).toDate();
    },
    async createToken() {
      const apiTokenForCreation: ApiTokenForCreationDto = {
        name: this.tokenForm.token.tokenName,
        expiresInDays: 0,
      };
      const expDate = moment(this.tokenForm.token.tokenExpirationDate);
      apiTokenForCreation.expiresInDays = Math.ceil(
        moment.duration(expDate.diff(today)).asDays(),
      );
      const createdToken =
        await this.userStore.createApiToken(apiTokenForCreation);
      await this.userStore.retrieveTokens();

      if (createdToken) {
        this.tokenForm.token.accessToken = createdToken.token ?? "";
        this.tokenForm.token.tokenName = "";
        this.isCreateModalVisible = true;
      }
    },
    copyToken() {
      navigator.clipboard.writeText(this.tokenForm.token.accessToken);
    },
    // -- delete selected token
    revokeToken(selectedToken: ApiTokenDto) {
      this.selectedTokenId = selectedToken.id ?? "";
      this.selectedTokenName = selectedToken.name ?? "";
      this.isRevokeModalVisible = true;
    },
    async confirmRevoke() {
      await this.userStore.deleteToken(this.selectedTokenId);
      await this.userStore.retrieveTokens();
      this.isRevokeModalVisible = false;
    },
    checkExpiration(expires: string | undefined) {
      const expiration = moment(expires);
      return today.isAfter(expiration) ?? false;
    },
    formatDate(date: string): string {
      return moment(date).format("DD.MM.YYYY");
    },
  },
});
</script>

<style scoped>
#accesstoken :deep(.table td) {
  vertical-align: middle;
  text-overflow: ellipsis;
  white-space: nowrap;
  overflow: hidden;
}
</style>
